CON
  ' current code only allows from 1Hz upwards 
  MIN_FREQUENCY = 1
  ' dunno which upper limit can be achieved by the SPIN-code        
  MAX_FREQUENCY = 7000
  
VAR
  byte   pin, presentTeeth, missingTeeth, cog
  long   frequencyRate

  long   pulse, sync, timing, localIndex
  long   stack[20]

PUB start(p, pt, mt, initFrequency)
  pin := p
  presentTeeth := pt
  missingTeeth := mt
  setFrequency( initFrequency )

  if cog
    cogstop( cog-1 )

  cog := cognew( crankPulser, @stack )+1

PUB setFrequency( newFrequ )
  frequencyRate := (newFrequ #> MIN_FREQUENCY ) <# MAX_FREQUENCY

  timing := clkfreq / frequencyRate
  pulse := timing >> 1

PUB getFrequency
  return frequencyRate
  
PRI crankPulser
  dira[pin] := 1                                                ' make output 

  frqa := 1
  phsa := 0
  ctra := (%00100 << 26) | pin                   ' setup counter for pin

  sync := cnt                                                   ' sync with system clock  
  repeat    
    repeat localIndex from 1 to (presentTeeth- missingTeeth)
      phsa := -pulse                                              ' create 1ms pulse
      waitcnt(sync += timing)                                     ' hold for current hz setting
    
    repeat localIndex from 1 to (missingTeeth)
      phsa := 0                                             ' create 1ms pulse
      waitcnt(sync += timing)



      